﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;


namespace SearchEngineExcercise_ConsoleBased
{
    class Program
    {
        static void Main(string[] args)
        {
            if (args.GetLength(0) == 1)
            {
                #region FileNames List
                //Files Path from command line parameter
                string FilesPath = args[0].ToString();

                //all files name in directory
                List<string> FilesName = new List<string>();

                DirectoryInfo Dinfo = new DirectoryInfo(FilesPath);

                //add all files into 
                foreach (FileSystemInfo Finfo in Dinfo.GetFileSystemInfos())
                {
                    FilesName.Add(Finfo.Name);

                }

                
                #endregion

                Console.WriteLine("Files Name Uploaded!\n");
                Console.WriteLine("Token Generation, Press Enter to Start");
                Console.ReadKey();
                Console.WriteLine(DateTime.Now.ToString());


                #region Token Generation
                //Token Generation
                List<KeyValuePair<string, string>> Tokens = new List<KeyValuePair<string, string>>();


                StreamReader rdr = null;
                String Linebuffer;
                string[] strArr;
                foreach (string filename in FilesName)
                {
                    //string fullpath = FilesPath + "\\" + filename;

                    rdr = new StreamReader(FilesPath + "\\" + filename);

                    //sb = new StringBuilder(rdr.ReadToEnd());

                    Linebuffer = rdr.ReadToEnd();
                    Linebuffer = Linebuffer.Replace('\n', ' ');
                    Linebuffer = Linebuffer.Replace('\t', ' ');
                    Linebuffer = Linebuffer.Replace('\r', ' ');



                    strArr = Linebuffer.Trim().Split(' ');

                    foreach (string token in strArr)
                    {
                        if (token != "")
                        {
                            Tokens.Add(new KeyValuePair<string, string>(token, filename));
                        }
                    }

                    rdr = null;
                    Linebuffer = "";

                }
                
                #endregion
                ////output to file
                //StreamWriter wtr = new StreamWriter("Tokens.tok");
                //foreach (KeyValuePair<string, string> item in Tokens)
                //{
                //    wtr.WriteLine(item.Key + " " + item.Value);
                //}

                //wtr.Close();

                //rdr.Close();
                //rdr.Dispose();

                Console.WriteLine("Done, Total Tokens Generator:" + Tokens.Count.ToString()+" Press Enters to Continue");
                Console.WriteLine(DateTime.Now.ToString());
                Console.ReadKey();

                Console.WriteLine("Generate Inverted Index, Press any key to start");
                Console.WriteLine(DateTime.Now.ToString());
                Console.ReadKey();

                #region InvertedIndexList Generation
                //Generate Inverted Inex

                SortedList<string, List<string>> InvertedIndex = new SortedList<string, List<string>>();

                foreach (KeyValuePair<string, string> item in Tokens)
                {
                    //key does not exist
                    if (InvertedIndex.Keys.IndexOf(item.Key) >= 0)
                    {

                        (InvertedIndex[item.Key]).Add(item.Value);
                    }
                    else
                    {
                        List<string> templist = new List<string>();
                        templist.Add(item.Value);

                        InvertedIndex.Add(item.Key, templist);

                    }
                } 
                #endregion

                
                Console.WriteLine("Done, Inverted Index List Created, Total:"+InvertedIndex.Count.ToString()+" (Press any key to continue)");
                Console.WriteLine(DateTime.Now.ToString());
                Console.ReadKey();

                Console.WriteLine("Two Word Query Search,Press any key to Start");
                Console.WriteLine(DateTime.Now.ToString());
                Console.ReadKey();

                #region Frequency
                //List<KeyValuePair<string, int>> Freq = new List<KeyValuePair<string, int>>();

                //foreach (KeyValuePair<string,List<string>> item in InvertedIndex)
                //{
                //    Freq.Add(new KeyValuePair<string,int>(item.Key,item.Value.Count()));
                //}


                ////output to file
                //StreamWriter wtr = new StreamWriter("FreqKey.tok");
                //StreamWriter wtr1 = new StreamWriter("FreqCount.tok");
                
                //foreach (KeyValuePair<string, int> item in Freq)
                //{
                //    wtr.WriteLine(item.Key);
                //    wtr1.WriteLine(item.Value);
                //}

                //wtr.Close();
                //wtr1.Close();

                #endregion


                #region TwoWordQuery Search
                //two Word Query Search
                List<KeyValuePair<string, string>> TwoWord = new List<KeyValuePair<string, string>>();
                List<string> MatchedfileName = new List<string>();

                //for limiting the search i can start from 45000
                for (int i = 45000; i < InvertedIndex.Count - 1; i++)
                {
                    KeyValuePair<string, List<string>> Token1 = InvertedIndex.ElementAt(i);

                    for (int j = 1 + i; j < InvertedIndex.Count; j++)
                    {
                        KeyValuePair<string, List<string>> Token2 = InvertedIndex.ElementAt(j);

                        //we need exacty one document
                        int MatchedCount = 0;

                        for (int k = 0; k < Token1.Value.Count; k++)
                        {
                            for (int l = 0; l < Token2.Value.Count; l++)
                            {
                                if (Token1.Value[k] == Token2.Value[l])
                                {
                                    if (MatchedCount == 0)
                                    {
                                        MatchedCount += 1;
                                    }
                                    else
                                    {
                                        //matched twice
                                        MatchedCount += 1; //make it two
                                        break;
                                    }
                                }
                            }

                            if (MatchedCount > 1) //more than one match
                            {
                                MatchedCount = 0; //clear
                                break;
                            }
                            else if (MatchedCount == 1)
                            {
                                TwoWord.Add(new KeyValuePair<string, string>(Token1.Key, Token2.Key));
                                //MatchedfileName.Add(token1
                            }
                        }
                    }

                    ////output to file
                    //StreamWriter wtr = new StreamWriter("f:\\TwoWordsQuery.tok");
                    //foreach (KeyValuePair<string, string> item in TwoWord)
                    //{
                    //    wtr.WriteLine(item.Key + " : " + item.Value);
                    //}

                    //wtr.Close();

                }

                #endregion

            }
            else
            {
                Console.WriteLine("Please check you Arguments Provided on command line/ remove space from arguement if there is any!");
                Console.ReadKey();

            }
            
        }
    }
}
